#buffon's needle 
#----------------

buf<-function(n)
{
        ttt <- NULL
        ttt[1] <- 0
        x  <- runif(n)
        th <- runif(n, 0, pi)
        st <- sin(th)
        for(i in 1:n) {
                if(st[i] > x[i])
                        ttt[i + 1] <- ttt[i] + 1
                else ttt[i + 1] <- ttt[i]
        }
        ttt
        if(ttt[n + 1] > 0)
                plot((0:n)[ttt > 0], 2*(0:n)[ttt > 0]/ttt[ttt > 0], type = "l", 
                        xlab = "number of simulations", ylab = 
                        "proportion of hits")
        else print("no successes")
        abline(pi, 0)
}

#Simulation by inversion
#-------------------------

"dsim"<-
function(n, inv.df)
{
        u <- runif(n)
        inv.df(u)
}

"inv.df.exp" <-
  function(x, lam = 1) { -(log(1-x))/lam}



#Rejection sampling
#---------------------


"rej.sim"<-
function(n)
{
        r <- rep(-99,n)
        for(i in 1:n) {
                t <- -1
                while(t < 0) {
                        x <- rexp(1, 1)
                        y <- runif(1, 0, exp( - x))
                        if(x > 1)
                                t <-  - y
                        else t <- x^2 * exp( - x) - y
                }
                r[i] <- x
        }
        r
}

#Ratio of uniforms simulation of a standard Cauchy
#---------------------------------------------------

ru.sim<-function(n)
{
r<-NULL
for(i in 1:n)
{
t<-1
while(t>0)
{
u<-runif(1,0,1)
v<-runif(1,-1,1)
t<-u^2 + v^2 -1
}
r[i] <-u/v
}
r
}


#Importance sampling example
#-----------------------------

"i.s"<-
function(n)
{
        x <- 2/runif(n)
        psi <- x^2/(2 * pi * (1 + x^2))
        mean(psi)
}


#Monte Carlo simulation of bivariate Gaussian probabilities
#-----------------------------------------------------------

"bvsim"<-
function(n, me, sd, ro)
{
        x <- rnorm(n, me[1], sd[1])
        y <- rnorm(n, me[2] + (ro * sd[2])/sd[1] * (x - me[1]), sd[2] * sqrt(1 - 
                ro * ro))
        cbind(x, y)
}


#Data augmentation for the genetic linkage example
#--------------------------------------------------

"gibbs1"<-
function(n, xa)
{
        z <- 20
        th <- 0.5
        z.o <- z
        th.o <- th
        for(j in 1:n) {
                th <- rbeta(1, z + xa[4] + 1, xa[2] + xa[3] + 1)
                p <- th/(th + 2)
                z <- rbinom(1, xa[1], p)
                z.o <- c(z.o, z)
                th.o <- c(th.o, th)
        }
        cbind(th.o, z.o)
}


#Poisson changepoint for coal mining diaster example
#----------------------------------------------------

"gibbs2"<-
function(n, dat, init, const)
{
        l <- NULL
        th <- init[1]
        la <- init[2]
        b1 <- init[3]
        b2 <- init[4]
        k <- init[5]
        a1 <- const[1]
        a2 <- const[2]
        c1 <- const[3]
        c2 <- const[4]
        d1 <- const[5]
        d2 <- const[6]
        nn <- length(dat)
        th.o <- NULL
        la.o <- NULL
        k.o <- NULL
        for(i in 1:n) {
                th <- rgamma(1, a1 + cumsum(dat)[k])/(k + b1)
                la <- rgamma(1, a2 + sum(dat) - cumsum(dat)[k])/(nn - k + b2)
                b1 <- rgamma(1, a1 + c1)/(th + d1)
                b2 <- rgamma(1, a2 + c2)/(la + d2)
                for(j in 1:nn) {
                        l[j] <- exp((la - th) * j) * (th/la)^(cumsum(dat)[j])
                }
                k <- sample(1:nn, size = 1, prob = l)
                th.o <- c(th.o, th)
                la.o <- c(la.o, la)
                k.o <- c(k.o, k)
        }
        cbind(th.o, la.o, k.o)
}



#Gibbs sampler for variance component model
#-------------------------------------------



gibbs3<-function(n = 10, dat = c(2, 3, 4, 5, 6, 7, 8, 9, 10, 12), groups = c(4, 6), 
        init = c(4, 5), init.mu = c(6, 7), init.sig2 = c(8, 9), prior = c(100, 
        100, 0, 0, 0))
{
#priors for variance of mu's, th, then prior mean for theta and 
#alpha and beta parameters for the inverse gammas
#
#dat is data, n = no of iterations, init.sig2 is a vector 
#of starting values for sig2
#init.mu is a vector of starting values for  mu, init gives starting valies for
#theta and the variance of the random effect
#groups gives the size of the groups - it should sum to the length of dat
#
        k <- length(groups)
        cum <- 1:k
        for(i in 1:k) {
                curr <- 0
                for(l in 1:i)
                        curr <- curr + groups[l]
                cum[i] <- curr
        }
        cum2 <- c(0, cum)
        mu <- init.mu
        sig2 <- init.sig2
        th <- init[1]
        si2 <- init[2]
        mu.o <- NULL
        sig2.o <- NULL
        th.o <- NULL
        si2.o <- NULL
        parsumdat <- 1:k
        for(i in 1:k) {
                curr <- 0
                for(l in (cum2[i] + 1):cum2[i + 1])
                        curr <- curr + dat[l]
                parsumdat[i] <- curr
        }
        for(i in 1:n) {
                for(j in 1:k) {
                        mu[j] <- rnorm(1, (sig2[j]^(-1) * parsumdat[j] + th * 
                                prior[1]^(-1))/(prior[1]^(-1) + sig2[j]^(-1) * 
                                groups[j]), 1/(prior[1]^(-1) + sig2[j]^(-1) * 
                                groups[j]))
                }
                for(j in 1:k) {
                        tempsum <- 0
                        for(l in (cum2[j] + 1):cum2[j + 1]) {
                                tempsum <- tempsum + (dat[l] - mu[j])^2/2
                        }
                        sig2[j] <- (prior[5] + tempsum)/(rgamma(1, prior[4] + 
                                groups[j]/2))
                }
                th <- rnorm(1, (prior[1]^(-1) * sum(mu) + prior[3] * si2^(-1))/(
                        k * prior[1]^(-1) + si2^(-1)), 1/(k * prior[1]^(-1) + 
                        si2^(-1)))
                si2 <- (prior[5] + sum((mu - th)^2/2))/rgamma(1, prior[4] + k/2
                        )
                mu.o <- rbind(mu.o, mu)
                sig2.o <- rbind(sig2.o, sig2)
                th.o <- c(th.o, th)
                si2.o <- c(si2.o, si2)
        }
        cbind(mu.o, sig2.o, si2.o, th.o)
}

"bet.mix"<-
function(x, a, b)
{
        s <- (x^(a - 1) * (1 - x)^(b - 1) * gamma(a + b))/gamma(a)/gamma(b)
        mean(s)
}


"bootstrap1"<-
function(x, nboot, theta, ...)
{
        z_list()
        data <- matrix(sample(x, size = length(x) * nboot, replace = T), nrow
                 = nboot)
        bd_apply(data, 1, theta, ...)
        est_theta(x,...)
        z$est_est
        z$distn_bd
        z$bias_mean(bd)-est
        z$se_sqrt(var(bd))
        z
}
"bootstrap2"<-
function(x, y, nboot, theta, ...)
{       z_list()
        data.x <- matrix(sample(x, size = length(x) * nboot, replace = T), nrow
                 = nboot)
        data.y <- matrix(sample(y, size = length(y) * nboot, replace = T), nrow
                 = nboot)
        data <- cbind(data.x, data.y)
        bd_apply(data, 1, theta, ...)
        est_theta(c(x,y),...)
        z$est_est
        z$distn_bd
        z$bias_mean(bd)-est
        z$se_sqrt(var(bd))
        z
 
}


"em.h"<-
function(x)
{
        dnorm(x)/(1 - pnorm(x))
}
"em.mc"<-
function(x, m, th.init)
{
        th <- th.init
        for(i in 1:length(m)) {
                p <- th/(2 + th)
                z <- rbinom(m[i], 125, p)
                me <- mean(z)
                th <- (me + x[4])/(me + x[2] + x[3] + x[4])
                cat(i, round(th, 5), fill = T)
        }
}
"em.reg"<-
function(x, n)
{
 m_dim(x)[1]
        a <- lm(x[, 2] ~ x[, 1])
        b <- coef(a)
        sig <- sqrt(deviance(a)/(m-2))
        cat(b, sig, fill = T)
        for(i in 1:n) {
                mu <- b[1] + b[2] * x[, 1]
                ez <- mu + sig * em.h((x[, 2] - mu)/sig)
                ez[x[,3]==0] <- x[x[,3]==0, 2]
                a <- lm(ez ~ x[, 1])
                b <- coef(a)
                ss <- sum((ez[x[,3]==0] - mu[x[,3]==0])^2)/m
                ss <- ss + (sig^2 * sum(((x[x[,3]==1, 2] - mu[x[,3]==1])/sig) * em.h((
                        x[x[,3]==1, 2] - mu[x[,3]==1])/sig) + 1))/m
                sig <- sqrt(ss)
                cat(b, sig, fill = T)
                abline(a, col = i)
        }
}
"m.hast"<-
function(n, xa)
{
        pi.f <- function(th, xa)
        {
                (2 + th)^xa[1] * (1 - th)^(xa[2] + xa[3]) * th^xa[4]
        }
        th <- 0.2
        th.o <- th
        for(j in 1:n) {
                y <- runif(1)
                al <- min(pi.f(y, xa)/pi.f(th, xa), 1)
                u <- runif(1)
                if(u < al)
                        th <- y
                th.o <- c(th.o, th)
        }
        th.o
}




"ru.sim"<-
function(n)
{
	r <- NULL
	for(i in 1:n) {
		t <- 1
		while(t > 0) {
			u <- runif(1, 0, 1)
			v <- runif(1, -1, 1)
			t <- u^2 + v^2 - 1
		}
		r[i] <- u/v
	}
	r
}
"si.fit"<-
function(m, n, xa)
{
	th <- runif(m)
	cat(mean(th), sqrt(var(th)), fill = T)
	p <- th/(th + 2)
	x <- rbinom(m, xa[1], p)
	ind <- sample(x, m, replace = T)
	for(j in 1:n) {
		th <- rbeta(m, x[ind] + x[4] + 1, xa[2] + xa[3] + 1)
		p <- th/(th + 2)
		x <- rbinom(m, xa[1], p)
		ind <- sample(x, m, replace = T)
		cat(mean(th), sqrt(var(th)), fill = T)
	}
	xx <- seq(0.01, 0.98999999999999999, by = 0.01)
	y <- bet.mix(xx, x + xa[4] + 1, rep(xa[2] + xa[3] + 1, m))
	plot(xx, y, type = "n")
	lines(spline(xx, y))
}
"theta1"<-
function(x, xdata)
{
	cor(xdata[x, 1], xdata[x, 2])
}
"theta2"<-
function(z, n)
{
	median(z[(n + 1):length(z)]) - median(z[1:n])
}
"theta3"<-
function(x, resid, beta, z1)
 + {
	y <- NULL
	y[1] <- z1
	for(i in 1:length(resid)) {
		y[i + 1] <- beta * y[i] + resid[x[i]]
	}
	ar.fit <- ar(y, aic = F, ord = 1)
	plot(y, type = "l")
	ar.fit$ar
}
"theta4"<-
function(x, xdata)
{
	mc.lo <- loess(xdata[x, 2] ~ xdata[x, 1], span = 1/3)
	y <- predict.loess(mc.lo, 1:60)
	lines(1:60, y)
}
"theta5"<-
function(x, xdata)
{
	ls <- lsfit(xdata[x, 1], xdata[x, 2])
	abline(ls)
	ls$coef
}
"theta6"<-
function(x, xdata)
{
	y <- x + xdata[, 2]
	ls <- lsfit(xdata[, 1], y)
	abline(ls)
	ls$coef
}


