\name{rej.sim}
\alias{rej.sim}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Rejection Sampling}

\description{
  Implementation of a rejection sampling algorithm to simulate from a truncated Gamma distribution.
}

\usage{
rej.sim(n)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{n}{number of simulations.}
}

\details{
  Implements the \bold{Algorithm 2.1} described in \bold{Chapter 2, Section 2.5.2}
  of the course notes.
  
  Illustrates an implementation of the rejection sampling algorithm to
  sample from a truncated Gamma distribution with density:
  \deqn{f(x) \propto x^2 exp(-x) ; 0 \leq x < 1
  }{f(x) \prop x^2 exp(-x) ; 0 \le x < 1}    

}

\value{
  A vector of length \code{n} with simulations from the truncated Gamma distribution.
}

\references{
    Coles, S, Roberts, G. and Jarner, S. (2001) \emph{Computer Intensive Methods}.
  Course notes. Dept Maths & Stats, Lancaster University.

  Course home page at:\cr
  \url{http://www.maths.lancs.ac.uk/~jarner/cim.html}.
}

\author{Stuart Coles}

%\note{ ~~further notes~~ }

% ~Make other sections like WARNING with \section{WARNING }{....} ~

%\seealso{}

\examples{
tg.sim <- rej.sim(100)
hist(tg.sim)
}

\keyword{distribution}%-- one or more ...
