# Coursework sheet 1: Simulation

# Solutions to questions 2, 3, 4 and 5
# --------------------------------------------------


# Various useful things:

motif()                  # opens a graphics window
dev.off()                # closes the graphics window

postscript("hist1.eps")  # prints to a postscript file
dev.off()                # closes the postscript file

# --------------------------------------------------
#                   Question 2
# --------------------------------------------------

invcau <- function(n) {

  tan(pi*(runif(n)-1/2))

}

# Plot a histogram and the true pdf

x <- invcau(100)
hist(x,probability=T)
box()
v <- seq(min(x),max(x),length=100)
f <- 1/(pi*(1+v*v))
lines(v,f)

# --------------------------------------------------
#                   Question 3
# --------------------------------------------------

bm <- function(n) {

  u1 <- runif(n)
  u2 <- runif(n)
  t  <- 2*pi*u1
  r  <- sqrt(-2*log(u2))
  x  <- r*cos(t)
  y  <- r*sin(t)
  cbind(x,y)
}

# Scatter plots and histograms

xy <- bm(1000)
plot(xy)

# The variance/covariance matrix
var(xy)

# Note that the correlation/covariance is (probably) not as close
# to 0 as you might expect. This of course does not imply that x and
# y are not independent. It does illustrate however that it is hard
# to estimate the true correlation in bivariate (or higher dimensional) data.

hist(xy[,1],probability=T)
box()
v <- seq(min(xy[,1]),max(xy[,1]),length=100)
f <- exp(-v*v)/sqrt(2*pi)
lines(v,f)

hist(xy[,2],probability=T)
box()
v <- seq(min(xy[,2]),max(xy[,2]),length=100)
f <- exp(-v*v)/sqrt(2*pi)
lines(v,f)


# --------------------------------------------------
#                   Question 4
# --------------------------------------------------

rejtri <- function(n) {

  r <- NULL
  for (i in 1:n) {
     repeat {
       x <- runif(1,-1,1)     # x uniform on [-1,1]
       y <- runif(1)          # y uniform on [0,1]
       if (y < 1-abs(x)) break
     }
     r[i] <- x
   }
  r
}

# Histogram and true density

x <- rejtri(1000)
hist(x,probability=T)
box()
v <- seq(min(x),max(x),length=100)
f <- 1-abs(v)
lines(v,f)

# --------------------------------------------------
#                   Question 5
# --------------------------------------------------

n  <- 1000
x  <- invcau(n)>2
p1  <- sum(x)/n
sd1 <- sqrt(var(x)/n)
ci1 <- c(p1-1.96*sd1,p1+1.96*sd1)
sd2 <- sqrt(p1*(1-p1)/(n-1))
ci2 <- c(p1-1.96*sd2,p1+1.96*sd2)
p1
sd1
ci1
sd2
ci2

u  <- runif(n)
x  <- 2/u
y  <- x*x/(2*pi*(1+x*x))
p2 <- sum(y)/n
sd3 <- sqrt(var(y)/n)
ci3 <- c(p2-1.96*sd3,p2+1.96*sd3)
p2
sd3
ci3

# Reduction in standard deviation
sd1/sd3

# True value of p
0.5-atan(2)/pi
